<?php
include('../ayarlar.php');
include "../../kutuphane/vendor-trendyol3/autoload.php";

use IS\PazarYeri\Trendyol\TrendyolClient;
use IS\PazarYeri\Trendyol\Helper\TrendyolException;

$trendyol = new TrendyolClient(); 
$trendyol->setSupplierId($supplier_id);
$trendyol->setUsername($api_username);
$trendyol->setPassword($api_password);



$siparisler = $trendyol->order->orderList(
	array(
		'startDate'          => time() - (86400 * 14),
		'page'               => 0,
		'size'               => 10,
		'status'             => 'Cancelled',
		'orderByField'       => 'CreatedDate',
		'orderByDirection'   => 'DESC',
	)
);



foreach ($siparisler->content as $key => $item) { //sipariş foreach

$shipmentAddress_fullAddress = $item->shipmentAddress->fullAddress;
$shipmentAddress_city        = $item->shipmentAddress->city;
$shipmentAddress_district    = $item->shipmentAddress->district;
$shipmentAddress_fullName    = $item->shipmentAddress->fullName;
$shipmentAddress_fullName    = addslashes($shipmentAddress_fullName);

$orderNumber                 = $item->orderNumber;
$grossAmount         		 = $item->grossAmount;
$totalDiscount      		 = $item->totalDiscount;
$customerEmail       		 = $item->customerEmail;
$customerId       			 = $item->customerId;
$id                          = $item->id;
$cargoTrackingNumber         = $item->cargoTrackingNumber;
$cargoTrackingLink           = $item->cargoTrackingLink;
$cargoProviderName      	 = $item->cargoProviderName;
$orderDate      			 = $item->orderDate;
$orderDate                   = date('Y-m-d H:i:s', $orderDate/1000);
$shipmentPackageStatus       = $item->shipmentPackageStatus;
$totalPrice       			 = $item->totalPrice;

$estimatedDeliveryStartDate  = $item->estimatedDeliveryStartDate;
$estimatedDeliveryStartDate  = date('Y-m-d H:i:s', $estimatedDeliveryStartDate/1000);
$estimatedDeliveryEndDate    = $item->estimatedDeliveryEndDate;
$estimatedDeliveryEndDate    = date('Y-m-d H:i:s', $estimatedDeliveryEndDate/1000);
$agreedDeliveryDate          = $item->agreedDeliveryDate;
$agreedDeliveryDate          = date('Y-m-d H:i:s', $agreedDeliveryDate/1000);

if(!$cargoTrackingLink){
$cargoTrackingLink = "";	
} else {
$bol_kod = explode("trackingId=",$cargoTrackingLink);
$cargoTrackingLink = $bol_kod[1];		
}



// kaydet sipariş
$stmt = $db3->prepare("SELECT count(*) FROM trendyol_siparis WHERE siparis_numarasi = ?");
$stmt->execute([$orderNumber]);
$count = $stmt->fetchColumn();
if (!$count) {
$query = $db3->query("INSERT INTO trendyol_siparis SET 
siparis_numarasi = '".$orderNumber."', 
siparis_tutari = '".$grossAmount."', 
indirim_tutari = '".$totalDiscount."', 
toplam_tutar = '".$totalPrice."',
paket_id = '".$id."',
shipmentAddress_fullName = '".$shipmentAddress_fullName."', 
siparis_mail = '".$customerEmail."',
musteri_id = '".$customerId."',
siparis_sehir_fatura = '".$shipmentAddress_city."',
siparis_ilce_fatura = '".$shipmentAddress_district."', 
siparis_adres_fatura = '".$shipmentAddress_fullAddress."', 
kargo_no = '".$cargoTrackingNumber."',
cargoTrackingLink = '".$cargoTrackingLink."',
kargo_firma = '".$cargoProviderName."', 
siparis_status = '".$shipmentPackageStatus."', 
siparis_tarih = '".$orderDate."',
tarih = '" . $anlik_zamanx . "',
agreedDeliveryDate = '".$agreedDeliveryDate."',
estimatedDeliveryStartDate = '".$estimatedDeliveryStartDate."',
estimatedDeliveryEndDate = '".$estimatedDeliveryEndDate."'")->fetch(PDO::FETCH_ASSOC);
echo "Eklendi -> $orderNumber - $shipmentPackageStatus - $orderDate<br>";
} else {
$query = $db3->query("UPDATE trendyol_siparis SET 
siparis_status = '".$shipmentPackageStatus."', 
paket_id = '".$id."',
shipmentAddress_fullName = '".$shipmentAddress_fullName."', 
kargo_firma = '".$cargoProviderName."',
kargo_no = '".$cargoTrackingNumber."',
cargoTrackingLink = '".$cargoTrackingLink."',
agreedDeliveryDate = '".$agreedDeliveryDate."',
estimatedDeliveryStartDate = '".$estimatedDeliveryStartDate."',
estimatedDeliveryEndDate = '".$estimatedDeliveryEndDate."' WHERE siparis_numarasi = '".$orderNumber."'")->fetch(PDO::FETCH_ASSOC);
echo "Güncellendi -> $orderNumber - $shipmentPackageStatus - $orderDate<br>";
}
// kaydet sipariş


foreach ($item->lines as $key => $item2) { //sipariş ürün foreach
	
$quantity 				 = $item2->quantity;
$productSize  			 = $item2->productSize;
$merchantSku  			 = $item2->merchantSku;
$productName  			 = $item2->productName;
$productName             = addslashes($productName);
$productCode  			 = $item2->productCode;
$amount       			 = $item2->amount;
$discount    			 = $item2->discount;
$productColor			 = $item2->productColor;
$barcode      			 = $item2->barcode;
$orderLineItemStatusName = $item2->orderLineItemStatusName;
$price                   = $item2->price;
$uniquecode              = $orderNumber."-".$barcode."-".$merchantSku;

$row3 = $db3->query("SELECT tasarimci FROM trendyol_product WHERE barcode = '".$urun_barkod."'")->fetch(PDO::FETCH_ASSOC);
$tasarimci = $row3['tasarimci'];


// kaydet sipariş ürün
$stmtx = $db3->prepare("SELECT count(*) FROM trendyol_siparis_urun WHERE uniquecode = ?");
$stmtx->execute([$uniquecode]);
$countx = $stmtx->fetchColumn();
if (!$countx) {
$query2 = $db3->query("INSERT INTO trendyol_siparis_urun SET 
siparis_numarasi = '".$orderNumber."', 
urun_barkod = '".$barcode."',
StatusName = '".$orderLineItemStatusName."',
urun_ismi = '".$productName."',
urun_beden = '".$productSize."',
urun_adet = '".$quantity."',
urun_renk = '".$productColor."',
urun_model = '".$merchantSku."',
urun_tasarimci = '".$tasarimci."',
urun_fiyat = '".$amount."',
urun_indirim = '".$discount."',
urun_toplam = '".$price."',
uniquecode = '".$uniquecode."'")->fetch(PDO::FETCH_ASSOC);
} else {
$query = $db3->query("UPDATE trendyol_siparis_urun SET StatusName = '".$orderLineItemStatusName."' WHERE uniquecode = '".$uniquecode."'")->fetch(PDO::FETCH_ASSOC);	
}
// kaydet sipariş ürün


} //sipariş ürün foreach
} //sipariş foreach


//print_r($siparisler);

?>